package com.millicom.microservice.service.adapters.soap.service;

import com.millicom.microservice.service.external.services.personalizado.ConsultarResponse;
import com.millicom.microservice.service.service.numero.temporal.Consultar;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ws.server.endpoint.annotation.Endpoint;
import org.springframework.ws.server.endpoint.annotation.PayloadRoot;
import org.springframework.ws.server.endpoint.annotation.RequestPayload;
import org.springframework.ws.server.endpoint.annotation.ResponsePayload;


@Endpoint
public class TemporalEndpoint {
    private static final String NAMESPACE_URI = "http://services.tigo.com.bo/";


    private final Consultar consultar;

    @Autowired
    public TemporalEndpoint(Consultar consultar) {
        this.consultar = consultar;
    }


    @PayloadRoot(localPart = "Consultar", namespace = NAMESPACE_URI)
    @ResponsePayload
    public ConsultarResponse consultar(@RequestPayload com.millicom.microservice.service.external.services.Consultar consultaRequest) {
        return consultar.consultar(consultaRequest.getConsultaRequest());

    }
}
