package com.millicom.microservice.service.service.numero.propiedades;

import com.millicom.microservice.service.service.numero.propiedades.map.PropiedadesCabeceras;
import com.millicom.microservice.service.service.numero.propiedades.map.PropiedadesRespuesta;
import com.millicom.microservice.service.service.numero.propiedades.map.PropiedadesVariableRuta;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service
public class PropiedadesImplementacion implements Propiedades {

    @Autowired
    private PropiedadesCabeceras propiedadesCabeceras;
    @Autowired
    private PropiedadesVariableRuta propiedadesVariableRuta;
    @Autowired
    private PropiedadesRespuesta propiedadesRespuesta;
    @Value("${service.numerotemporal.operacion}")
    private String operacion;
    @Value("${service.numerotemporal.sistema}")
    private String sistema;
    @Value("${service.numerotemporal.devolver.cabeceras.del.legado}")
    private boolean devolverCabeceras;



    @Override
    public Map<String, String> getMapHeader() {
        return propiedadesCabeceras.getHeader();
    }

    @Override
    public Map<String, String> getMapPathVars() {
        return propiedadesVariableRuta.getVars();
    }

    @Override
    public Map<String, String> getMapResponse() {
        return propiedadesRespuesta.getErrors();
    }

    @Override
    public String getOperacion() {
        return operacion;
    }

    @Override
    public String getSistema() {
        return sistema;
    }

    @Override
    public boolean isDevolverCabeceras() {
        return devolverCabeceras;
    }

}
